import io.netty.channel.Channel;
import wei.yigulu.iec104.nettyconfig.Iec104SlaverBuilder;
import wei.yigulu.iec104.util.SendDataFrameHelper;

public class StartHttpServer {
    public static void main(String[] args) throws Exception {
        //104端口
        Integer port1 = 2404;
        //页面端口
        Integer port2 = 2405;
        Integer tem1;
        Integer tem2;
        if (args.length == 1 || args.length > 2) {
            throw new RuntimeException("请输入两个端口，参数1为104Slver端口，参数2为配置页面端口");
        }
        if (args.length == 2) {
            try {
                tem1 = Integer.parseInt(args[0]);
                if (tem1 > 65535 || tem1 < 0) {
                    throw new RuntimeException("参数1应为0-65535整数");
                }
            } catch (Exception e) {
                throw new RuntimeException("参数1应为0-65535整数");
            }
            try {
                tem2 = Integer.parseInt(args[1]);
                if (tem1 > 65535 || tem1 < 0) {
                    throw new RuntimeException("参数2应为0-65535整数");
                }
            } catch (Exception e) {
                throw new RuntimeException("参数2应为0-65535整数");
            }
            if (tem1.intValue() == tem2.intValue()) {
                throw new RuntimeException("参数1与参数2不能相同");
            }
            port1 = tem1;
            port2 = tem2;
        }
        Iec104SlaverBuilder iec104SlaverBuilder = new Iec104SlaverBuilder(port1);
        iec104SlaverBuilder.createByUnBlock();
        RecurringTaskContainer.getInstance().addRecurringTask(60, "向对端发送突发上送", () -> {
            if (iec104SlaverBuilder.getChannels().size() > 0) {
                for (Channel c : iec104SlaverBuilder.getChannels()) {
                    SendDataFrameHelper.sendYxDataFrameDiscontinuity(c, ProtocolDataContainer.getInstance().getBooleans(), 1, 3, iec104SlaverBuilder.getLog());
                    SendDataFrameHelper.sendYcDataFrameDiscontinuity(c, ProtocolDataContainer.getInstance().getNumbers(), 1, 3, iec104SlaverBuilder.getLog());
                }
            }
            return null;
        });
        HttpServer httpServer = new HttpServer(port2);
        httpServer.start();
    }

}
